﻿@{
    ViewBag.Title = "Company Financial Data";
    Layout = "~/Views/Shared/_FixedLayout.cshtml";
}

<script src="~/Content/plugins/autoNumeric-1.9.18.js"></script>


<script type="text/javascript">

    $(function () {
        $('#txtcashequivalent').autoNumeric('init', { lZero: 'deny', aSep: ',', mDec: 2,vMin: '-999999999999', vMax: '999999999999' });
        $('#txtnetworkingcapital').autoNumeric('init', { lZero: 'deny', aSep: ',', mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtfixedassets').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtotherassets').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtotherliabilities').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtminorityinterestbs').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtequity').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtrevenue').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtcostofrevenue').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtoperatingexpenses').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtnonoperatingincome').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txttaxexpense').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtminorityinterestpl').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtdividend').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtcostofrevenue_fix').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtoperatingprofit').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtnetincome').autoNumeric('init', { lZero: 'deny', aSep: ',',mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtoperatingcashflow').autoNumeric('init', { lZero: 'deny', aSep: ',', mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtms').autoNumeric('init', { lZero: 'deny', aSep: ',', mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtssi').autoNumeric('init', { lZero: 'deny', aSep: ',', mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        $('#txtcsi').autoNumeric('init', { lZero: 'deny', aSep: ',', mDec: 2, vMin: '-999999999999', vMax: '999999999999' });
        
    });

    function Save() {
        //validation
        if ($('#txtcompany').val().length == 0 || $('#txtyear').val().length == 0 ||
            $('#txtcashequivalent').val().length == 0 || $('#txtnetworkingcapital').val().length == 0 ||
                $('#txtfixedassets').val().length == 0 || $('#txtotherassets').val().length == 0 ||
                $('#txtotherliabilities').val().length == 0 || $('#txtminorityinterestbs').val().length == 0 ||
                $('#txtequity').val().length == 0 || $('#txtrevenue').val().length == 0 ||
                $('#txtcostofrevenue').val().length == 0 || $('#txtoperatingexpenses').val().length == 0 ||
                $('#txtnonoperatingincome').val().length == 0 || $('#txttaxexpense').val().length == 0 ||
                $('#txtminorityinterestpl').val().length == 0 || $('#txtdividend').val().length == 0 ||
                $('#txtcostofrevenue_fix').val().length == 0 || $('#txtoperatingprofit').val().length == 0 ||
                $('#txtnetincome').val().length == 0 || $('#txtoperatingcashflow').val().length == 0 ||
                $('#txtms').val().length == 0 || $('#txtcsi').val().length == 0 || $('#txtssi').val().length == 0
            ) {

            bootbox.alert("<i class='fa fa-warning fa-2x'></i> Please fill mandatory field (<label class='required'></label>)", function () {
                setTimeout(function () { }, 500);
            });
        } else {

            //confirmation
            bootbox.confirm({
                title: "<i class='fa fa-warning fa-2x'></i> Save Confirmation",
                message: 'Are you sure you want to save this data. <br>If not, click Cancel',
                buttons: {
                    'cancel': {
                        label: '<i class="fa fa-times"></i> Cancel',
                        className: 'btn-default pull-left'
                    },
                    'confirm': {
                        label: '<i class="fa fa-check"></i> Yes, Continue save',
                        className: 'btn-primary pull-right'
                    }
                },
                callback: function (result) {
                    if (result) {
                        var CompanyFinDataList = [
                             {
                                         id: '0',
                                 company: $('#txtcompany').val(),
                                 year: $('#txtyear').val(),
                                 cashequivalent: $('#txtcashequivalent').val(),
                                 networkingcapital: $('#txtnetworkingcapital').val(),
                                 fixedassets: $('#txtfixedassets').val(),
                                 otherassets: $('#txtotherassets').val(),
                                 otherliabilities: $('#txtotherliabilities').val(),
                                 minorityinterestbs: $('#txtminorityinterestbs').val(),
                                 equity: $('#txtequity').val(),
                                 revenue: $('#txtrevenue').val(),
                                 costofrevenue: $('#txtcostofrevenue').val(),
                                 operatingexpenses: $('#txtoperatingexpenses').val(),
                                 nonoperatingincome: $('#txtnonoperatingincome').val(),
                                 taxexpense: $('#txttaxexpense').val(),
                                 minorityinterestpl: $('#txtminorityinterestpl').val(),
                                 dividend: $('#txtdividend').val(),
                                 costofrevenue_fix: $('#txtcostofrevenue_fix').val(),
                                 operatingprofit: $('#txtoperatingprofit').val(),
                                 netincome: $('#txtnetincome').val(),
                                 operatingcashflow: $('#txtoperatingcashflow').val(),
                                 ms: $('#txtms').val(),
                                 ssi: $('#txtssi').val(),
                                 csi: $('#txtcsi').val()

                             }
                        ];

                        CompanyFinDataList.push();

                        var formData = new FormData();
                        formData.append("CompanyFinDataList", JSON.stringify(CompanyFinDataList));


                        //Save Process
                        $.ajax({
                            type: "POST",
                            url: '@Url.Action("SaveCompanyFinData", "CompanyFinData")',
                            data: formData,
                            dataType: 'json',
                            contentType: false,
                            processData: false,
                            //beforeSend: function () {
                            //    //$("#loader").show();
                            //},
                            success: function (data) {
                                bootbox.dialog({
                                    message: data.message,
                                    title: data.title,
                                    buttons: {
                                        main: {
                                            label: "<i class='fa fa-check'></i> Ok",
                                            className: "btn-primary",
                                            callback: function () {
                                                if (result) {
                                                    if (data.status) {
                                                        window.location.href = '@Url.Action("CompanyFinData", "CompanyFinData")';
                                                    }
                                                }
                                            }
                                        }
                                    }
                                });
                            }
                        });

                    }
                }
            });
        }
        return true;
    }

    //txtoperatingprofit = txtrevenue - txtcostofrevenue - txtoperatingexpenses

    function calcOperatingProfit(){
        var operatingprofit = 0.00; var revenue = 0.00;
        var costofrevenue = 0.00; var operatingexpenses = 0.00;

        revenue = parseFloat(document.getElementById("txtrevenue").value.replace(/,/g, ''));
        costofrevenue = parseFloat(document.getElementById("txtcostofrevenue").value.replace(/,/g, ''));
        operatingexpenses = parseFloat(document.getElementById("txtoperatingexpenses").value.replace(/,/g, ''));
        

        operatingprofit = revenue - costofrevenue - operatingexpenses;
        //alert('revenue : ' + revenue + ';\ncostofrevenue : ' + costofrevenue + ';\noperatingexpenses : ' + operatingexpenses + ';\noperatingprofit : ' + operatingprofit);
        
        document.getElementById("txtoperatingprofit").value = operatingprofit.toFixed(2);

        calcNetIncome();

        return false;
    }



    //txtnetincome = txtrevenue - txtcostofrevenue - txtoperatingexpenses + txtnonoperatingincome - txttaxexpense


    function calcNetIncome() {
        var operatingprofit = 0.00; var netincome = 0.00;
        var nonoperatingincome = 0.00; var taxexpense = 0.00;

        operatingprofit = parseFloat(document.getElementById("txtoperatingprofit").value.replace(/,/g, ''));
        nonoperatingincome = parseFloat(document.getElementById("txtnonoperatingincome").value.replace(/,/g, ''));
        taxexpense = parseFloat(document.getElementById("txttaxexpense").value.replace(/,/g, ''));

        netincome = operatingprofit + nonoperatingincome - taxexpense;

        document.getElementById("txtnetincome").value = netincome.toFixed(2);

        operatingCashFlow();

        return false;
    }
    //txtoperatingcashflow = txtnetworkingcapital + txtnetincome


    function operatingCashFlow() {
        var operatingcashflow = 0.00; var networkingcapital = 0.00;
        var netincome = 0.00;

        networkingcapital = parseFloat(document.getElementById("txtnetworkingcapital").value.replace(/,/g, ''));
        netincome = parseFloat(document.getElementById("txtnetincome").value.replace(/,/g, ''));

        operatingcashflow = netincome + networkingcapital;

        document.getElementById("txtoperatingcashflow").value = operatingcashflow.toFixed(2);

        return false;
    }


    $(document).ready(function () {


        $("#btnSave").click(function () {
            Save();
        });

        $("#txtrevenue").focusout(function () { // focusout method to bind function
            calcOperatingProfit();
        });	
        $("#txtcostofrevenue").focusout(function () { // focusout method to bind function
            calcOperatingProfit();
        });
        $("#txtoperatingexpenses").focusout(function () { // focusout method to bind function
            calcOperatingProfit();
        });
        $("#txtnonoperatingincome").focusout(function () { // focusout method to bind function
            calcNetIncome();
        });
        $("#txttaxexpense").focusout(function () { // focusout method to bind function
            calcNetIncome();
        });

        $("#txtnetworkingcapital").focusout(function () { // focusout method to bind function
            operatingCashFlow();
        });
        $("#txtnetincome").focusout(function () { // focusout method to bind function
            operatingCashFlow();
        });
    });




</script>

<style>
    .label-def-margin {
        margin-top: 6px;
    }

    .required:after {
        content: "*";
        color: red;
    }
</style>


<div class="col-sm-12">
    <div class="panel panel-primary" style="margin-bottom: 0;">
        <div class="panel-heading">
            Add Company Financial Data
        </div>
        <div class="panel-body">
            <!--company-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtcompany">Company</label></div>
                <div class="col-sm-4"><input class="form-control" disabled="disabled" type="text" value="Toyota Astra Motor" id="txtcompany" /></div>
            </div>
            <!--year-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtyear">Year</label></div>
                <div class="col-sm-4"><input class="form-control" type="text" id="txtyear" /></div>
                <div class="col-sm-4"><label class="label-def-margin text-red">Note : in million rupiah</label></div>
            </div>
            <hr />
            <!--cashequivalent-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtcashequivalent">Cash Equivalent</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtcashequivalent">

                    </div>
                </div>

                <!--networkingcapital-->

                <div class="col-sm-2"><label class="required label-def-margin" for="txtnetworkingcapital">Networking Capital</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtnetworkingcapital">

                    </div>
                </div>
            </div>
            <!--fixedassets-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtfixedassets">Fixed Assets</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtfixedassets">

                    </div>
                </div>

                <!--otherassets-->

                <div class="col-sm-2"><label class="required label-def-margin" for="txtotherassets">Other Assets</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtotherassets">

                    </div>
                </div>
            </div>
            <!--otherliabilities-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtotherliabilities">Other Liabilities</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtotherliabilities">

                    </div>
                </div>

                <!--minorityinterestbs-->

                <div class="col-sm-2"><label class="required label-def-margin" for="txtminorityinterestbs">Minority Interest BS</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtminorityinterestbs">

                    </div>
                </div>
            </div>
            <!--equity-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtequity">Equity</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtequity">

                    </div>
                </div>

                <!--revenue-->

                <div class="col-sm-2"><label class="required label-def-margin" for="txtrevenue">Revenue</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtrevenue">

                    </div>
                </div>
            </div>
            <!--costofrevenue-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtcostofrevenue">Cost of Revenue</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtcostofrevenue">

                    </div>
                </div>

                <!--operatingexpenses-->

                <div class="col-sm-2"><label class="required label-def-margin" for="txtoperatingexpenses">Operating Expenses</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtoperatingexpenses">

                    </div>
                </div>
            </div>
            <!--nonoperatingincome-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtnonoperatingincome">Non Operating Income</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtnonoperatingincome">

                    </div>
                </div>

                <!--taxexpense-->

                <div class="col-sm-2"><label class="required label-def-margin" for="txttaxexpense">Tax Expense</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txttaxexpense">

                    </div>
                </div>
            </div>
            <!--minorityinterestpl-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtminorityinterestpl">Minority Interest PL</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtminorityinterestpl">

                    </div>
                </div>

                <!--dividend-->

                <div class="col-sm-2"><label class="required label-def-margin" for="txtdividend">Dividend</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtdividend">

                    </div>
                </div>
            </div>
            <!--costofrevenue_fix-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtcostofrevenue_fix">Cost of Revenue Fix</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" value="" id="txtcostofrevenue_fix">

                    </div>
                </div>

                <!--operatingprofit-->

                <div class="col-sm-2"><label class="required label-def-margin" for="txtoperatingprofit">Operating Profit</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" disabled="disabled" value="" id="txtoperatingprofit">

                    </div>
                </div>
            </div>
            <!--netincome-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtnetincome">Net Income</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" disabled="disabled" value="" id="txtnetincome">
                    </div>
                </div>
                <!--operatingcashflow-->
                <div class="col-sm-2"><label class="required label-def-margin" for="txtoperatingcashflow">Operating Cash Flow</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <span class="input-group-addon">IDR</span>
                        <input type="text" class="form-control text-right" disabled="disabled" value="" id="txtoperatingcashflow">
                    </div>
                </div>
            </div>
            <!--ms-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtms">M/S</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <input type="text" class="form-control text-right" value="" id="txtms">
                        <span class="input-group-addon">%</span>
                    </div>
                </div>
                <!--ssi sales-->
                <div class="col-sm-2"><label class="required label-def-margin" for="txtssi">SSI (Sales)</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <input type="text" class="form-control text-right" value="" id="txtssi">
                        <span class="input-group-addon">%</span>
                    </div>
                </div>
            </div>
            <!--csi-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtcsi">CSI (After Sales)</label></div>
                <div class="col-sm-4">
                    <div class="input-group">
                        <input type="text" class="form-control text-right" value="" id="txtcsi">
                        <span class="input-group-addon">%</span>
                    </div>
                </div>

            </div>

        </div>
        <div class="panel-footer">
            <div class="row">
                <div class="col-sm-1">
                    <button type="button" class="btn btn-primary" id="btnSave">
                        <span class="glyphicon glyphicon-floppy-disk"></span> Save
                    </button>
                </div>
                <div class="col-sm-1">
                    <button type="button" class="btn btn-primary" onclick="@("window.location.href='" + @Url.Action("CompanyFinData", "CompanyFinData") + "'");">
                        <span class="glyphicon glyphicon-circle-arrow-left"></span> Back
                    </button>
                </div>
            </div>
        </div>
    </div>
</div>